<?php

// Updated by yas 2016/06/03
// Updated by yas 2016/05/28
// Updated by yas 2016/05/25
// Updated by yas 2016/05/20
// Updated by yas 2016/05/19
// Updated by yas 2016/05/11
// Updated by yas 2016/05/10
// Created by yas 2016/04/19.
namespace Drupal\aws_cloud\Aws\Ec2;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface defining a SecurityGroup entity.
 *
 * @ingroup aws_cloud
 */
interface SecurityGroupInterface extends ContentEntityInterface, EntityOwnerInterface {
  // Add get/set methods for your configuration properties here.
  /**
   * {@inheritdoc}
   */
  public function getCloudContext();

  /**
   * {@inheritdoc}
   */
  public function getDescription();

  /**
   * {@inheritdoc}
   */
  public function getGroupId();

  /**
   * {@inheritdoc}
   */
  public function setGroupId($group_id = '');

  /**
   * {@inheritdoc}
   */
  public function getGroupName();

  /**
   * {@inheritdoc}
   */
  public function getGroupDescription();

  /**
   * {@inheritdoc}
   */
  public function getVpcId();

  /**
   * {@inheritdoc}
   */
  public function created();

  /**
   * {@inheritdoc}
   */
  public function changed();

  /**
   * {@inheritdoc}
   */
  public function getRefreshed();

  /**
   * {@inheritdoc}
   */
  public function getIpPermission();

  /**
   * {@inheritdoc}
   */
  public function getOutboundPermission();

  /**
   * {@inheritdoc}
   */
  public function isDefaultVpc();

  /**
   * {@inheritdoc}
   */
  public function setDefaultVpc($default);

  /**
   * {@inheritdoc}
   */
  public function setRefreshed($time);

}
