<?php

namespace Drupal\aws_cloud\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * IpPermission field validation
 *
 * @Constraint(
 *   id = "ip_permission_data",
 *   label = @Translation("IP Permission", context = "Validation"),
 * )
 */
class IpPermissionDataConstraint extends Constraint {

  public $to_port_not_numeric = "The To Port is not numeric.";

  public $from_port_not_numeric = "The From Port is not numeric.";

  public $ip_4_is_empty = "CIDR ip is empty.";

  public $ip_4_value = "CIDR ip is not valid. Single ip addresses must be in x.x.x.x/32 notation.";

  public $ip_6_value = "CIDR ipv6 is not valid. Single ip addresses must be in x.x.x.x/32 notation.";

  public $ip_6_is_empty = "CIDR ipv6 is empty.";

  public $group_name_is_empty = "Group name is empty.";

  public $group_id_is_empty = "Group id is empty.";

  public $no_security_group = "No security group found.";

  public $to_port_greater = "From Port is greater than To Port.";

}
